#################################################################
#								#
# Copyright (c) 2019-2021 YottaDB LLC and/or its subsidiaries.	#
# All rights reserved.						#
#								#
#	This source code contains the intellectual property	#
#	of its copyright holder(s), and is made available	#
#	under a license.  If you do not know the terms of	#
#	the license, please stop and do not read further.	#
#								#
#################################################################

load test_helpers

setup() {
  init_test
  createdb
  load_fixture names.sql
  load_fixture names.zwr
}

@test "TNK01 : OCTO311 : Miscellaneous tests of NULL keyword" {
  # TNK01_errors.sql cannot be used with `run_query_in_octo_and_postgres_and_crosscheck_multiple_queries` because of error
  # returns from queries (Postgres and Octo issue different error outputs). Need a reference file.
  load_fixture TNK01_errors.sql subtest
  verify_output TNK01_errors output.txt noinfo nodebug
  mv clean_output.txt errors_clean_output.txt
  # TNK01_noerrors_names.sql can be used with `run_query_in_octo_and_postgres_and_crosscheck_multiple_queries` because all queries
  # generate valid output (i.e. no errors at all). No reference file needed for this.
  # TNK01_noerrors_names.sql has 250+ queries so run only a small random fraction (20%) of them to cut down test runtime.
  run_query_in_octo_and_postgres_and_crosscheck_multiple_queries names TNK01_noerrors_names.sql 0.20 "trim_trailing_zeroes"
  load_fixture customers.sql
  load_fixture customers.zwr
  # TNK01_noerrors_customers.sql can be used with `run_query_in_octo_and_postgres_and_crosscheck_multiple_queries` because all queries
  # generate valid output (i.e. no errors at all). No reference file needed for this.
  run_query_in_octo_and_postgres_and_crosscheck_multiple_queries customers TNK01_noerrors_customers.sql
}

@test "TNK02 : OCTO443 : Multiple OUTER JOIN returns incorrect results" {
  run_query_in_octo_and_postgres_and_crosscheck_multiple_queries names TNK02.sql
}

@test "TNK03 : OCTO336 : ORDER BY ASC should sort NULL values AFTER non-NULL values and BEFORE for DESC" {
  load_fixture customers.sql
  load_fixture customers.zwr
  run_query_in_octo_and_postgres_and_crosscheck_multiple_queries customers TNK03.sql
}

@test "TNK04 : OCTO311 : Tests law of the excluded fourth (in WHERE clauses)" {
  run_query_in_octo_and_postgres_and_crosscheck_multiple_queries names TNK04.sql
}

@test "TNK05 : OCTO687 : Test of '' vs NULL" {
	# TODO: Use run_query_in_octo_and_postgres_and_crosscheck_multiple_queries when YDBOcto#687 is fixed.
	# Cannot use it now because Octo and Postgres currently handle '' vs NULL differently.
	load_fixture TNK05.sql subtest novv
	verify_output TNK05 output.txt noinfo nodebug
}
